
I2C_EEPROM_test:

;I2C_EEPROM.mbas,60 :: 		sub procedure test(dim err as byte)
;I2C_EEPROM.mbas,61 :: 		if(err = _I2C_TIMEOUT_RD) then
	MOVF        FARG_test_err+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_I2C_EEPROM_test2
;I2C_EEPROM.mbas,62 :: 		RA0_bit = 1
	BSF         RA0_bit+0, BitPos(RA0_bit+0) 
L_I2C_EEPROM_test2:
;I2C_EEPROM.mbas,64 :: 		if(err = _I2C_TIMEOUT_WR) then
	MOVF        FARG_test_err+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_I2C_EEPROM_test5
;I2C_EEPROM.mbas,65 :: 		RA1_bit = 1
	BSF         RA1_bit+0, BitPos(RA1_bit+0) 
L_I2C_EEPROM_test5:
;I2C_EEPROM.mbas,67 :: 		end sub
L_end_test:
	RETURN      0
; end of I2C_EEPROM_test

_I2C_EEPROM_Init:

;I2C_EEPROM.mbas,70 :: 		sub procedure I2C_EEPROM_Init()
;I2C_EEPROM.mbas,71 :: 		I2C1_Init(100000)
	MOVLW       80
	MOVWF       SSP1ADD+0 
	CALL        _I2C1_Init+0, 0
;I2C_EEPROM.mbas,72 :: 		I2C1_SetTimeoutCallback(1000,@test)     ' enable error flag
	MOVLW       232
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+0 
	MOVLW       3
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+1 
	MOVLW       0
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+2 
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeout+3 
	MOVLW       I2C_EEPROM_test+0
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeoutCallback_ptr+0 
	MOVLW       hi_addr(I2C_EEPROM_test+0)
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeoutCallback_ptr+1 
	MOVLW       FARG_test_err+0
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeoutCallback_ptr+2 
	MOVLW       hi_addr(FARG_test_err+0)
	MOVWF       FARG_I2C1_SetTimeoutCallback_timeoutCallback_ptr+3 
	CALL        _I2C1_SetTimeoutCallback+0, 0
;I2C_EEPROM.mbas,73 :: 		end sub
L_end_I2C_EEPROM_Init:
	RETURN      0
; end of _I2C_EEPROM_Init

_I2C_EEPROM_BadWrRd:

;I2C_EEPROM.mbas,76 :: 		sub procedure I2C_EEPROM_BadWrRd()
;I2C_EEPROM.mbas,77 :: 		I2C1_Start()                 ' issue TWI (Two Wire Interface - aka I2C) start signal
	CALL        _I2C1_Start+0, 0
;I2C_EEPROM.mbas,78 :: 		I2C1_Wr(0)                   ' bad write and read will report error on port A
	CLRF        FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,79 :: 		I2C1_Rd(0)                   ' as a demonstration of SetTimeoutCallback
	CLRF        FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
;I2C_EEPROM.mbas,80 :: 		I2C1_Stop()
	CALL        _I2C1_Stop+0, 0
;I2C_EEPROM.mbas,81 :: 		end sub
L_end_I2C_EEPROM_BadWrRd:
	RETURN      0
; end of _I2C_EEPROM_BadWrRd

_I2C_EEPROM_IdleWait:

;I2C_EEPROM.mbas,84 :: 		sub procedure I2C_EEPROM_IdleWait()
;I2C_EEPROM.mbas,85 :: 		while (I2C1_Is_Idle() = 0)
L__I2C_EEPROM_IdleWait11:
	CALL        _I2C1_Is_Idle+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__I2C_EEPROM_IdleWait12
;I2C_EEPROM.mbas,86 :: 		nop                      ' Wait for i2c bus to become idle
	NOP
;I2C_EEPROM.mbas,87 :: 		wend
	GOTO        L__I2C_EEPROM_IdleWait11
L__I2C_EEPROM_IdleWait12:
;I2C_EEPROM.mbas,88 :: 		end sub
L_end_I2C_EEPROM_IdleWait:
	RETURN      0
; end of _I2C_EEPROM_IdleWait

_I2C_EEPROM_WrSingle:

;I2C_EEPROM.mbas,92 :: 		dim eAddr as byte          ' this is the eeprom address byte
;I2C_EEPROM.mbas,96 :: 		eAddr = (hi(wAddr) and %00000011) << 1
	MOVLW       3
	ANDWF       FARG_I2C_EEPROM_WrSingle_wAddr+1, 0 
	MOVWF       I2C_EEPROM_WrSingle_eAddr+0 
	RLCF        I2C_EEPROM_WrSingle_eAddr+0, 1 
	BCF         I2C_EEPROM_WrSingle_eAddr+0, 0 
;I2C_EEPROM.mbas,97 :: 		eAddr = eAddr or EEPROM_ADDR ' add the rest of the address bits
	MOVLW       160
	IORWF       I2C_EEPROM_WrSingle_eAddr+0, 1 
;I2C_EEPROM.mbas,99 :: 		I2C1_Start()                 ' issue TWI start signal (Two Wire Interface, aka I2C)
	CALL        _I2C1_Start+0, 0
;I2C_EEPROM.mbas,100 :: 		I2C1_Wr(eAddr)               ' send byte via TWI
	MOVF        I2C_EEPROM_WrSingle_eAddr+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,101 :: 		I2C1_Wr(lo(wAddr))           ' send low byte (address of EEPROM location)
	MOVF        FARG_I2C_EEPROM_WrSingle_wAddr+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,102 :: 		I2C1_Wr(wData)               ' send data (data to be written)
	MOVF        FARG_I2C_EEPROM_WrSingle_wData+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,103 :: 		I2C1_Stop()
	CALL        _I2C1_Stop+0, 0
;I2C_EEPROM.mbas,104 :: 		end sub
L_end_I2C_EEPROM_WrSingle:
	RETURN      0
; end of _I2C_EEPROM_WrSingle

_I2C_EEPROM_RdSingle:

;I2C_EEPROM.mbas,109 :: 		dim eAddr as byte          ' eeprom address byte
;I2C_EEPROM.mbas,113 :: 		eAddr = (hi(rAddr) and %00000011) << 1
	MOVLW       3
	ANDWF       FARG_I2C_EEPROM_RdSingle_rAddr+1, 0 
	MOVWF       I2C_EEPROM_RdSingle_eAddr+0 
	RLCF        I2C_EEPROM_RdSingle_eAddr+0, 1 
	BCF         I2C_EEPROM_RdSingle_eAddr+0, 0 
;I2C_EEPROM.mbas,114 :: 		eAddr = eAddr or EEPROM_ADDR ' add the rest of the address bits
	MOVLW       160
	IORWF       I2C_EEPROM_RdSingle_eAddr+0, 1 
;I2C_EEPROM.mbas,116 :: 		I2C1_Start()               ' issue TWI start signal
	CALL        _I2C1_Start+0, 0
;I2C_EEPROM.mbas,117 :: 		I2C1_Wr(eAddr)             ' send byte via TWI  (device address + W)
	MOVF        I2C_EEPROM_RdSingle_eAddr+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,118 :: 		I2C1_Wr(lo(rAddr))         ' send byte (data address)
	MOVF        FARG_I2C_EEPROM_RdSingle_rAddr+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,119 :: 		I2C1_Start()               ' issue TWI signal repeated start
	CALL        _I2C1_Start+0, 0
;I2C_EEPROM.mbas,120 :: 		I2C1_Wr(eAddr+1)           ' send byte (device address + Read bit)
	MOVF        I2C_EEPROM_RdSingle_eAddr+0, 0 
	ADDLW       1
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,121 :: 		rslt = I2C1_Rd(0)          ' Read the data (NO acknowledge)
	CLRF        FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
	MOVF        R0, 0 
	MOVWF       I2C_EEPROM_RdSingle_rslt+0 
;I2C_EEPROM.mbas,122 :: 		I2C_EEPROM_IdleWait        ' wait for read operation to finish
	CALL        _I2C_EEPROM_IdleWait+0, 0
;I2C_EEPROM.mbas,123 :: 		I2C1_Stop()
	CALL        _I2C1_Stop+0, 0
;I2C_EEPROM.mbas,124 :: 		result= rslt
	MOVF        I2C_EEPROM_RdSingle_rslt+0, 0 
	MOVWF       I2C_EEPROM_RdSingle_local_result+0 
;I2C_EEPROM.mbas,125 :: 		end sub
	MOVF        I2C_EEPROM_RdSingle_local_result+0, 0 
	MOVWF       R0 
L_end_I2C_EEPROM_RdSingle:
	RETURN      0
; end of _I2C_EEPROM_RdSingle

_I2C_EEPROM_RdSeq:

;I2C_EEPROM.mbas,130 :: 		dim eAddr as byte          ' this is the eeprom address byte
;I2C_EEPROM.mbas,134 :: 		eAddr = (hi(rAddr) and %00000011) << 1
	MOVLW       3
	ANDWF       FARG_I2C_EEPROM_RdSeq_rAddr+1, 0 
	MOVWF       I2C_EEPROM_RdSeq_eAddr+0 
	RLCF        I2C_EEPROM_RdSeq_eAddr+0, 1 
	BCF         I2C_EEPROM_RdSeq_eAddr+0, 0 
;I2C_EEPROM.mbas,135 :: 		eAddr = eAddr or EEPROM_ADDR ' add the rest of the address bits
	MOVLW       160
	IORWF       I2C_EEPROM_RdSeq_eAddr+0, 1 
;I2C_EEPROM.mbas,137 :: 		I2C1_Start()               ' issue TWI start signal
	CALL        _I2C1_Start+0, 0
;I2C_EEPROM.mbas,138 :: 		I2C1_Wr(eAddr)             ' send byte via TWI  (device address + W)
	MOVF        I2C_EEPROM_RdSeq_eAddr+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,139 :: 		I2C1_Wr(lo(rAddr))         ' send byte (address of EEPROM location)
	MOVF        FARG_I2C_EEPROM_RdSeq_rAddr+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,140 :: 		I2C1_Start()               ' issue TWI signal repeated start
	CALL        _I2C1_Start+0, 0
;I2C_EEPROM.mbas,141 :: 		I2C1_Wr(eAddr+1)           ' send byte (device address + R)
	MOVF        I2C_EEPROM_RdSeq_eAddr+0, 0 
	ADDLW       1
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;I2C_EEPROM.mbas,142 :: 		counter = 0
	CLRF        I2C_EEPROM_RdSeq_counter+0 
;I2C_EEPROM.mbas,143 :: 		dec(rLen)                  ' read all but last byte
	DECF        FARG_I2C_EEPROM_RdSeq_rLen+0, 1 
;I2C_EEPROM.mbas,144 :: 		while (counter < rLen)
L__I2C_EEPROM_RdSeq19:
	MOVF        FARG_I2C_EEPROM_RdSeq_rLen+0, 0 
	SUBWF       I2C_EEPROM_RdSeq_counter+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__I2C_EEPROM_RdSeq20
;I2C_EEPROM.mbas,145 :: 		rdData[counter] = I2C1_Rd(1) ' read data (YES acknowledge)
	MOVF        I2C_EEPROM_RdSeq_counter+0, 0 
	ADDWF       FARG_I2C_EEPROM_RdSeq_rdData+0, 0 
	MOVWF       FLOC__I2C_EEPROM_RdSeq+0 
	MOVLW       0
	ADDWFC      FARG_I2C_EEPROM_RdSeq_rdData+1, 0 
	MOVWF       FLOC__I2C_EEPROM_RdSeq+1 
	MOVLW       1
	MOVWF       FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
	MOVFF       FLOC__I2C_EEPROM_RdSeq+0, FSR1
	MOVFF       FLOC__I2C_EEPROM_RdSeq+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;I2C_EEPROM.mbas,146 :: 		I2C_EEPROM_IdleWait
	CALL        _I2C_EEPROM_IdleWait+0, 0
;I2C_EEPROM.mbas,147 :: 		Inc(counter)
	INCF        I2C_EEPROM_RdSeq_counter+0, 1 
;I2C_EEPROM.mbas,148 :: 		wend
	GOTO        L__I2C_EEPROM_RdSeq19
L__I2C_EEPROM_RdSeq20:
;I2C_EEPROM.mbas,149 :: 		rdData[counter] = I2C1_Rd(0)   ' last data is read WITH ack
	MOVF        I2C_EEPROM_RdSeq_counter+0, 0 
	ADDWF       FARG_I2C_EEPROM_RdSeq_rdData+0, 0 
	MOVWF       FLOC__I2C_EEPROM_RdSeq+0 
	MOVLW       0
	ADDWFC      FARG_I2C_EEPROM_RdSeq_rdData+1, 0 
	MOVWF       FLOC__I2C_EEPROM_RdSeq+1 
	CLRF        FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
	MOVFF       FLOC__I2C_EEPROM_RdSeq+0, FSR1
	MOVFF       FLOC__I2C_EEPROM_RdSeq+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;I2C_EEPROM.mbas,150 :: 		I2C1_Stop()
	CALL        _I2C1_Stop+0, 0
;I2C_EEPROM.mbas,151 :: 		end sub
L_end_I2C_EEPROM_RdSeq:
	RETURN      0
; end of _I2C_EEPROM_RdSeq
